<?php
/**
 * webEdition CMS
 *
 * $Rev: 8384 $
 * $Author: mokraemer $
 * $Date: 2014-10-07 18:49:11 +0200 (Tue, 07 Oct 2014) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @category   webEdition
 * @package none
 * @license    http://www.gnu.org/copyleft/gpl.html  GPL
 */
we_html_tools::protect();
echo we_html_element::jsElement('top.opener.top.toggleBusy(0);');
$cmd2 = we_base_request::_(we_base_request::BOOL, 'we_cmd', false, 2);

if($cmd === 'ok'){
	$wf_text = we_base_request::_(we_base_request::STRING, 'wf_text');
	$wf_select = we_base_request::_(we_base_request::INT, 'wf_select');
	if(we_workflow_utility::insertDocInWorkflow($we_doc->ID, $we_doc->Table, $wf_select, $_SESSION["user"]["ID"], $wf_text)){
		$msg = g_l('modules_workflow', '[' . stripTblPrefix($we_doc->Table) . '][in_workflow_ok]');
		$msgType = we_message_reporting::WE_MESSAGE_NOTICE;
		if($_SESSION['weS']['we_mode'] == we_base_constants::MODE_SEE){
			$script = "opener.top.we_cmd('switch_edit_page'," . we_base_constants::WE_EDITPAGE_PREVIEW . ",'" . $we_transaction . "');";
		} else if($_SESSION['weS']['we_mode'] == we_base_constants::MODE_NORMAL){
			$script = 'opener.top.weEditorFrameController.getActiveDocumentReference().frames[3].location.reload();';
		}

		if($cmd2){ // make same new
			$we_doc->makeSameNew();
			$we_doc->saveInSession($_SESSION['weS']['we_data'][$we_transaction]); // save the changed object in session
			$script .= 'opener.top.we_cmd("switch_edit_page","' . $we_doc->EditPageNr . '","' . $we_transaction . '");'; // wird in Templ eingef�gt
		} elseif(($we_doc->EditPageNr == we_base_constants::WE_EDITPAGE_PROPERTIES || $we_doc->EditPageNr == we_base_constants::WE_EDITPAGE_INFO)){
			$script .= 'opener.top.we_cmd("switch_edit_page","' . $we_doc->EditPageNr . '","' . $we_transaction . '");'; // wird in Templ eingef�gt
		}
	} else {
		$msg = g_l('modules_workflow', '[' . stripTblPrefix($we_doc->Table) . '][in_workflow_notok]');
		$msgType = we_message_reporting::WE_MESSAGE_ERROR;
		if($_SESSION['weS']['we_mode'] == we_base_constants::MODE_SEE){
			$script = "opener.top.we_cmd('switch_edit_page'," . we_base_constants::WE_EDITPAGE_PREVIEW . ",'" . $we_transaction . "');";
		} else if($_SESSION['weS']['we_mode'] == we_base_constants::MODE_NORMAL){
			$script = '';
		}
	}
	echo we_html_element::jsElement($script . we_message_reporting::getShowMessageCall($msg, $msgType) . 'self.close();');
}
echo STYLESHEET;
?>
</head>

<body class="weDialogBody">
	<center>
		<?php
		if($cmd != 'ok'){
			$all = array();
			$wfDoc = ($we_doc->Table == FILE_TABLE ?
					we_workflow_utility::getWorkflowDocumentForDoc($GLOBALS['DB_WE'], $we_doc->DocType, $we_doc->Category, $we_doc->ParentID, $all) :
					we_workflow_utility::getWorkflowDocumentForObject($GLOBALS['DB_WE'], $we_doc->TableID, $we_doc->Category, $we_doc->ParentID));
			$wfID = $wfDoc->workflowID;
			if($wfID){
				?>
				<form action="<?php echo WEBEDITION_DIR; ?>we_cmd.php" method="post">
					<?php
					$wf_select = '<select name="wf_select" size="1">';
					$wfs = we_workflow_utility::getAllWorkflows(we_workflow_workflow::STATE_ACTIVE, $we_doc->Table, $all);
					foreach($wfs as $wID => $wfname){
						$wf_select .= '<option value="' . $wID . '"' . (($wID == $wfID) ? ' selected' : '') . '>' . oldHtmlspecialchars($wfname) . "</option>\n";
					}
					$wf_select .= '</select>';

					$okbut = we_html_button::create_button("ok", "javascript:document.forms[0].submit()");
					$cancelbut = we_html_button::create_button("cancel", "javascript:top.close()");

					$content = '<table border="0" cellpadding="0" cellspacing="0">';

					if(permissionhandler::hasPerm("PUBLISH")){
						$wf_textarea = '<textarea name="wf_text" rows="5" cols="50" style="left:10px;right:10px;height:150px;"></textarea>';
						$content .= '
<tr>
	<td class="defaultfont">' . g_l('modules_workflow', '[workflow]') . '</td>
</tr>
<tr>
	<td>' . $wf_select . '</td>
</tr>
<tr>
	<td>' . we_html_tools::getPixel(2, 5) . '</td>
</tr>';
					} else {
						$wf_textarea = '<textarea name="wf_text" rows="7" cols="50" style="left:10px;right:10px;height:190px"></textarea>';
						$content .= '<input type="hidden" name="wf_select" value="' . $wfID . '" />';
					}
					$content .= '
<tr>
	<td class="defaultfont">
		' . g_l('modules_workflow', '[message]') . '</td>
</tr>
<tr>
	<td>' . $wf_textarea . '</td>
</tr>
</table>';

					echo we_html_tools::htmlDialogLayout($content, g_l('modules_workflow', '[in_workflow]'), we_html_button::position_yes_no_cancel($okbut, '', $cancelbut)) . '
<input type="hidden" name="cmd" value="ok" />
<input type="hidden" name="we_cmd[0]" value="' . we_base_request::_(we_base_request::STRING, 'we_cmd', '', 0) . '" />
<input type="hidden" name="we_cmd[1]" value="' . $we_transaction . '" />
<input type="hidden" name="we_cmd[2]" value="' . $cmd2 . '" />';
					?>
				</form>
				<?php
			} else {
				echo we_html_element::jsElement(
					we_message_reporting::getShowMessageCall(g_l('modules_workflow', ($we_doc->Table == FILE_TABLE ? '[no_wf_defined]' : '[no_wf_defined_object]')), we_message_reporting::WE_MESSAGE_ERROR) .
					'top.close();');
			}
		}
		?>
	</center>
</body>

</html>